<?php
/*
  $Id: view_counter, v 1.0 2012/07/01 by Jack York - oscommerce-solution.com

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce
  Portions Copyright 2012 oscommerce-solution.com

  Released under the GNU General Public License
*/
 //get the IP. The HTTP_CLIENT_IP and HTTP_X_FORWARDED_FOR return for proxies and may not be accurate
 switch (true) {  
     case (!empty($_SERVER['HTTP_CLIENT_IP'])) && filter_var(@$_SERVER['HTTP_CLIENT_IP'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4) : $thisIP = $_SERVER['HTTP_CLIENT_IP']; break;
     case (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) && filter_var(@$_SERVER['HTTP_X_FORWARDED_FOR'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4) : $thisIP = $_SERVER['HTTP_X_FORWARDED_FOR']; break;
     case (filter_var($_SERVER['REMOTE_ADDR'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) : $thisIP = $_SERVER['REMOTE_ADDR']; break;
     case (filter_var($_SERVER['REMOTE_ADDR'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV6) && VIEW_COUNTER_ALLOW_IPV6 == 'false') : return;
     default: return; //probably an invalid IP
 } 
 
 include_once('includes/languages/' . $language . '/view_counter.php');
  
 function IsSearchBot($userAgent) {
     $searchbotStr = 'Ask Jeeves|AdsBot-Google|Google|Googlebot|FeedFetcher-Google|AdsBot-Google-Mobile|APIs-Google|Googlebot-Image|googleweblight|Googlebot-News|Storebot-Google|Googlebot-Video|Mediapartners-Google|msnbot|msnbot-media|bingbot|Yahoo|Yahoo|Slurp|Applebot|AbachoBOT|accoona|AcioRobot|Ahrefs|ASPSeek|CocoCrawler|Dumbot|FAST-WebCrawler|baidu|BOTW|Baiduspider|GeonaBot|Gigabot|HenryTheMiragorobot|Lycos|MJ12bot|MSRBOT|Scooter|AltaVista|IDBot|eStyle|Rambler|Scrubby|Bloglines subscriber|Charlotte|Charlotte t China|DotBot|Java VM|LinkWalker|Linguee|LiteFinder|QihooBot|Seekbot|Sogou head spider|Sogou web spider|Sosospider|Sosoimagespider|Superdownloads Spiderman|thefind|WebAlta Crawler|Yandex|Yeti|YodaoBot|ZyBorg';
     return ((preg_match("/$searchbotStr/i", $userAgent, $out) > 0) ? $out[0] : '');
 }

 function SetVisitorSpoofedName($viewSqlArray) {
     global $language;
     include_once(DIR_FS_CATALOG . 'includes/languages/' . $language . '/view_counter.php');

     if (isset($_SESSION['customer_id'])) {
         $vc_query = tep_db_query("select customers_firstname, customers_lastname from customers where customers_id='" . (int)$_SESSION['customer_id'] . "'");
         if (tep_db_num_rows($vc_query) > 0) {
             $db = tep_db_fetch_array($vc_query);
             $viewSqlArray['isbot'] = 2; //the IP was already shown to be a bot so set the flag
             $viewSqlArray['bot_name'] = $db['customers_firstname'] . ' ' . $db['customers_lastname'] .  ' ' . TEXT_SPOOFED_AS . IsSearchBot($_SERVER['HTTP_USER_AGENT']); //store the name of the bot                 
         }
     } else {
         $viewSqlArray['isbot'] = 0; //the IP was already shown to be a bot so set the flag
         $viewSqlArray['bot_name'] = TEXT_SPOOFED_AS . IsSearchBot($_SERVER['HTTP_USER_AGENT']); //store the name of the bot     
     }
     return $viewSqlArray;
 }
 
 $spoofedAction = false;
 $viewSqlArray = ['bot_name' => '', 'isbot' => ''];
 $viewSqlArray['ip'] = $thisIP;
 $viewSqlArray['user_agent'] = $_SERVER['HTTP_USER_AGENT'];
 $viewSqlArray['remote_host'] = ($_SERVER['REMOTE_HOST'] ?? '');
 
 $view_check_query = tep_db_query("select isbot, bot_name from view_counter where ip_number = INET_ATON('" . tep_db_input($viewSqlArray['ip']) . "')");
 $view_check = []; //increase the scope
 $found = false; //use instead of array since checking is faster
   
 if (tep_db_num_rows($view_check_query) > 0) {
     $view_check = tep_db_fetch_array($view_check_query);
     $found = true;
 }
 
 $ua = $_SERVER['HTTP_USER_AGENT'];
 
 if (! $found) { //not a previous identified IP
     global $spider_flag;
     
     if ($spider_flag) {
         $bot = IsSearchBot($ua);
         if (! isset($bot[1])) { //name not found
             if (($pos = strpos($ua, 'http')) !== false) { //if http://botname.com
                 $bot = substr($ua, $pos + 7);             // is now botname.com
                 if (($pos = strpos($bot, '.')) !== false) {
                     $bot = substr($bot, 0, -($pos - 1));
                 }               
             }
         }
         
         $viewSqlArray['isbot'] = 1;
         $viewSqlArray['bot_name'] = (isset($bot[1]) ? $bot : 'No Bot ID');
     } else {    
     
         $hostname = gethostbyaddr($viewSqlArray['ip']);
         if (preg_match("/search\.msn\.com$/", $hostname)) { //special case for msn since they don't always follow the rules
             $viewSqlArray['isbot'] = 1;
             $viewSqlArray['bot_name'] = 'msnbot';
         } elseif (isset($_SESSION['customer_id'])) { //not found and is a logged in customer
             $vc_query = tep_db_query("select customers_firstname, customers_lastname from customers where customers_id='" . (int)$_SESSION['customer_id'] . "'");
             if (tep_db_num_rows($vc_query) > 0) {
                 $db = tep_db_fetch_array($vc_query);
                 $viewSqlArray['isbot'] = 0; 
                 $viewSqlArray['bot_name'] = $db['customers_firstname'] . ' ' . $db['customers_lastname']; //store the customers name                 
                 $spoofedAction = false;
             }         
         }     
     }  
 } elseif ($view_check['isbot']) { //only if this is a previously found bot
      if (isset($_SESSION['customer_id'])) {
         $vc_query = tep_db_query("select customers_firstname, customers_lastname from customers where customers_id='" . (int)$_SESSION['customer_id'] . "'");
         if (tep_db_num_rows($vc_query) > 0) {
             $db = tep_db_fetch_array($vc_query);
             $viewSqlArray['isbot'] = 2; //the IP was already shown to be a bot so set the flag
             $viewSqlArray['bot_name'] = $db['customers_firstname'] . ' ' . $db['customers_lastname'] . ' spoofed as ' .IsSearchBot($_SERVER['HTTP_USER_AGENT']); //store the name of the bot                 
             $spoofedAction = true;
         }
     } else {
         if (! isset($viewSqlArray['bot_name'][1])) {
             $bot = IsSearchBot($ua);
             
             if (! isset($bot[1])) { //name not found
                 if (($pos = strpos($ua, 'http')) !== false) { //if http://botname.com
                     $bot = substr($ua, $pos + 7);             // is now botname.com
                     if (($pos = strpos($bot, '.')) !== false) {
                         $bot = substr($bot, 0, -($pos - 1));
                     }               
                 }
             }             
             $view_check['bot_name'] = (isset($bot[1]) ? $bot : 'No Bot ID');
         }

         $viewSqlArray['isbot'] = 1; //the IP was already shown to be a bot so set the flag
         $viewSqlArray['bot_name'] = $view_check['bot_name']; //store the name of the bot as previously recorded    
     }
 } elseif (isset($_SESSION['customer_id'])) {
     $vc_query = tep_db_query("select customers_firstname, customers_lastname from customers where customers_id='" . (int)$_SESSION['customer_id'] . "'");
     if (tep_db_num_rows($vc_query) > 0) {
         $db = tep_db_fetch_array($vc_query);
         $viewSqlArray['isbot'] = 0; //the IP was already shown to be a bot so set the flag
         $viewSqlArray['bot_name'] = $db['customers_firstname'] . ' ' . $db['customers_lastname']; //store the name of the bot                 
         $spoofedAction = false;
     }
 } else {
    $viewSqlArray['bot_name'] = '';
    $viewSqlArray['isbot'] = 0; 
     $bot = IsSearchBot($_SERVER['HTTP_USER_AGENT']);
     if (isset($bot[1])) {
         $viewSqlArray['bot_name'] = $bot;
         $viewSqlArray['isbot'] = 1; 
     }    
 } 

 //check for spoofing
 if ($viewSqlArray['isbot'] && (stristr($ua, 'msnbot') || stristr($ua, 'bingbot') || stristr($ua, 'googlebot') || stristr(strtolower(gethostbyaddr($thisIP)), 'google'))) {
     
     //it's pretending to be MSN's bot or Google's bot
     $hostname = gethostbyaddr($thisIP);
     
     if (!preg_match("/\.googlebot\.com$/", $hostname) && !preg_match("/search\.msn\.com$/", $hostname)){
         //the hostname does not belong to either live.com or googlebot.com.
         //Remember the UA already said it is either MSNBot or Googlebot.
         //So it's a spammer.
         $viewSqlArray = SetVisitorSpoofedName($viewSqlArray);
         $spoofedAction = true;
     } else {
         //Now we have a hit that half-passes the check. One last go:
         $real_ip = gethostbyname($hostname);
         
         if ($thisIP != $real_ip){
             //spammer!
            $viewSqlArray = SetVisitorSpoofedName($viewSqlArray);
            $spoofedAction = true;
         } else {
             //real bot
             $viewSqlArray['isbot'] = 1;
             $viewSqlArray['bot_name'] = IsSearchBot($_SERVER['HTTP_USER_AGENT']); 
         }
     }
 }

 if (VIEW_COUNTER_BLOCK_COUNTRIES_SHOP != 'Off' && ! defined('DIR_WS_ADMIN')) {
     if (VIEW_COUNTER_BLOCK_COUNTRIES_BOTS == 'Off' || (VIEW_COUNTER_BLOCK_COUNTRIES_BOTS == 'On' && $viewSqlArray['isbot'] == 0)) {
         include('includes/modules/view_counter_country_block.php');
     }	 
 }
 $viewSqlArray['isadmin'] = '';  //needed to not get missing argument error
 if (defined('DIR_WS_ADMIN') && strpos($_SERVER['PHP_SELF'], DIR_WS_ADMIN) !== false) {
     $viewSqlArray['isadmin'] = DIR_WS_ADMIN;
 } 

 $viewSqlArray['file'] = basename($_SERVER['PHP_SELF']);
 $viewSqlArray['arg'] = (strpos($viewSqlArray['file'], 'server_error.php') !== false ? basename($_SERVER['REQUEST_URI']) : $_SERVER['QUERY_STRING']);
 $viewSqlArray['method'] = $_SERVER['REQUEST_METHOD'];
 $viewSqlArray['time'] = $_SERVER['REQUEST_TIME'];
 
 if (($pos = strpos($viewSqlArray['arg'], '?osCsid')) !== false) {
     $viewSqlArray['arg'] = substr($viewSqlArray['arg'], 0, $pos);
 } elseif (($pos = strpos($viewSqlArray['arg'], '&osCsid')) !== false) {
     $viewSqlArray['arg'] = substr($viewSqlArray['arg'], 0, $pos);
 } elseif (($pos = strpos($viewSqlArray['arg'], 'osCsid')) !== false) {
     $viewSqlArray['arg'] = substr($viewSqlArray['arg'], 0, $pos);
 } 

 if (VIEW_COUNTER_DEBUG_TRACKING == 'Server') {
     $locn = 'includes/view_counter_debug_trace';
     foreach ($viewSqlArray as $key => $data) {
         error_log('VC Key: ' .$key . ' Data: ' . $data ."\n", 3, $locn);
     }  
     foreach ($_SERVER as $key => $data) {
         error_log('SE Key: ' .$key . ' Data: ' . $data ."\n", 3, $locn);
     }  
     error_log("\n", 3, $locn);
 }

 /******************************************************************************
 Access to an invalid location has occurred or a suspicious entry in the url was 
 found. If the IP does not belong to a bot, either ban the IP or notify the shop 
 owner or both, depending upon the ban bot setting.
 ******************************************************************************/
 if (! $viewSqlArray['isbot'] && VIEW_COUNTER_BAD_BOT_TRAP != 'Off' && ! defined('DIR_WS_ADMIN')) {
     include_once('includes/functions/view_counter.php');
     
     if (! IgnoreThisIP($viewSqlArray['ip'])) {
     
         if (strpos($_SERVER['REQUEST_URI'], 'trap') !== false) {
             HandleVCBan($viewSqlArray['ip'], true);
             return;
         }         
         
         if (! isset($GLOBALS['customer_id'])) { //ignore customers because return from Paypal may trigger the below code
             
             //This array is also stored in functions in admin so update it if this is changed.
             $cmpArry = array("(\<|%3C)script(>|%3E)", "base64_encode", "(\<|%3C).*iframe", "(\<|%3C)(.*)(\>|%3E)", "javascript:",
                              "eval\(\$_", "filesmanager", "javascript:", "mysql_query", "..\/cmd", "phpinfo\(", "\/iframe", "\$_GET",
                              "\$_POST", "\$_SESSION", "\$_REQUEST", "\$_SERVER", "\$_ENV", "GLOBALS\[", "\$HTTP_",
                              "autoLoadConfig", "php\/login", "alert\(", "convert\(", "mysite\.com",
                              "misc.php", "cltreq.asp", "owssvr.dll", "cmd.exe", "awstats", "phpmyadmin", "openwebmail", "formmail",
                              "drop table", "from table", "IDSAlert", "exec", "link_connect", "xp_dirtree", "action=select",
                              "action=%2fshopping_cart.php", "action=%5cshopping_cart.php", "action=shopping_cart.php"
                              ); 
             //Check for hacking attacks                             
             foreach ($cmpArry as $test) {
                 if (preg_match('/' . $test . '/i', $viewSqlArray['arg'])) {
                                       
                     if (VIEW_COUNTER_DEBUG_TRACKING == 'Spoofing') {
                         error_log("Failed arg match on " . $viewSqlArray['arg'] . " for IP " . $viewSqlArray['ip'] . "\n", 3, 'includes/view_counter_debug_trace');  
                     }
                     
                     HandleVCBan($viewSqlArray['ip']);
                     break;
                 } 
             }
         }
     }
 }       
  
 $view_check_query = tep_db_query("select view_count from view_counter
  where ip_number = INET_ATON('". tep_db_input($viewSqlArray['ip']) . "') and 
        language_id=" . (int)$languages_id . " and 
        file_name='"  . tep_db_input($viewSqlArray['file']) . "' and 
        arg='"        . tep_db_input($viewSqlArray['arg']) . "'" 
 );

 if (tep_db_num_rows($view_check_query) > 0) {   
 
     $view_check = tep_db_fetch_array($view_check_query);
     $cnt = $view_check['view_count'] + 1;
     tep_db_query("update view_counter set view_count = " . (int)$cnt . ", ip_active=1, last_date = now() " .  
      " where file_name = '" . tep_db_input($viewSqlArray['file']) . "' and " .
      "       arg  = '" .      tep_db_input($viewSqlArray['arg']) . "' and " .
      "       language_id  = " . (int)$languages_id . " and " .
      "       ip_number = INET_ATON('" . tep_db_input($viewSqlArray['ip']) . "' ) and " . 
      "       session_id = '" .tep_db_input(tep_session_id()) . "'");
 } else { 
  
     if (isset($_SERVER['HTTP_REFERER'])) {
         $refer_data = addslashes(tep_db_input(urldecode($_SERVER['HTTP_REFERER'])));
         $refer_data = explode('?', $refer_data);
     } else {
         $refer_data = array(0 => '', 1 => '');
     }   
    	$referrer=$refer_data[0];
    	$referrer_query = (isset($refer_data[1]) ? $refer_data[1] : '');
  
     $insert_sql_data =
      " file_name = '" . tep_db_input($viewSqlArray['file']) . "', " .
      " arg = '" . tep_db_input($viewSqlArray['arg']) . "', " . 
      " view_count = 1, " .
      " ip_number = INET_ATON( '" . $viewSqlArray['ip'] . "' ), " .
      " ip_active = 1, " .
      " session_id = '" . tep_db_input(tep_session_id()) . "', " . 
      " isbot = " . (int)$viewSqlArray['isbot'] . "," .
      " isadmin = '" . tep_db_input($viewSqlArray['isadmin']) . "', " .
      " last_date = now(), " .
      " bot_name = '" . tep_db_input($viewSqlArray['bot_name']) . "', " .
      " referrer = '" . tep_db_input($referrer) ."', " .
      " referrer_query = '" . tep_db_input($referrer_query) . "', " .
      " user_agent = '" . tep_db_input($viewSqlArray['user_agent']) . "', " .
      " remote_host = '" . tep_db_input($viewSqlArray['remote_host']) . "', " .
      " language_id = " . (int)$languages_id
     ;
   
     tep_db_query("insert view_counter set " . $insert_sql_data); //can't use perform due to apostrophes added to inet_aton string
     tep_db_query("insert view_counter_storage set " . $insert_sql_data);
 }
  
 /**** BEGIN KILL A SESSION AS ENTERED IN WHO'S ONLINE ****/   
 if (VIEW_COUNTER_ENABLE_KILL_SESSION == 'true') {
      $session_kill_query = tep_db_query("select session_msg as msg from view_counter_session_kill where session_id = '" . tep_db_input(tep_session_id()) . "'");
      
      if (tep_db_num_rows($session_kill_query) > 0) {
          $db = tep_db_fetch_array($session_kill_query);
          if (tep_not_null($db['msg'])) {
              $msg = $db['msg'];
              tep_db_query("delete from view_counter_session_kill where session_id = '" . tep_db_input(tep_session_id()) . "'");
          } else { //this is a kill message
              $sid = tep_session_id();
              if (tep_session_is_registered('cart') && is_object($cart)) {
                  if ($cart->count_contents() > 0) {
                      $cart->reset(true);
                  }
              }
              
              tep_db_query("delete from view_counter_session_kill where session_id = '" . tep_db_input(tep_session_id()) . "'");
              tep_session_destroy($sid);
              tep_session_unregister($sid);
              tep_session_close();
              unset($sid);
              $msg = TEXT_VIEW_COUNTER_KILL_MESSAGE;
          }
          echo '<script type="text/javascript">alert("'. $msg .'");</script>';
      }  
  }
  /**** END KILL A SESSION AS ENTERED IN WHO'S ONLINE ****/
